Regular.filter("formatDate",
function(t) {
    return $Date.getFullDate(new Date(t))
});
var $CONF = {
    appName: "mail4app"
},
MailDetail = Regular.extend({
    template: "#container",
    data: {
        ext: ["7z", "csv", "default", "excel", "htm", "html", "mp3", "mp4", "pdf", "ppt", "rar", "txt", "word", "zip", "img"],
        mail: {
            attachments: [],
            subject: "",
            content: "",
            ext: "default",
            sentDate: new Date,
            from: "",
            to: [],
            cc: []
        },
        errorMsg: "",
        error: !0,
        hideDetail: !0
    },
    init: function() {
        if ("1" === sessionStorage["expand"]) this.expand()
    },
    uniqueArray: function(e) {
        for (var i = [], t = 0, r = e.length; r > t; t++) {
            for (var n = t + 1; r > n; n++) if (e[t] === e[n]) n = ++t;
            i.push(e[t])
        }
        return i
    },
    getRealEmail: function(e) {
        var t = e.match(/<([^<>]*)>/g) || [];
        if (t.length) {
            var n = t[t.length - 1];
            return n.substring(1, n.length - 1)
        }
        return e
    },
    showActionSheet: function() {
        var t = this;
        FNJSBridge.call("actionsheet", {
            title: "",
            items: [{
                name: "回复",
                value: 1
            },
            {
                name: "回复全部",
                value: 2
            },
            {
                name: "转发",
                value: 3
            }]
        },
        function(r) {
            var n, e, s = {
                1 : "reply",
                2 : "replyAll",
                3 : "forward"
            },
            a = t.data.mail.from.slice(),
            o = t.data.mail.cc ? t.data.mail.cc.slice() : [],
            h = s[r.data.value];

            switch (r.data.value) {
            case 1:
                n = [a];
                e = [];
                break;
            case 2:
                try {
                    n = [a];
                    e = o.concat(t.data.mail.to || []);
                    e = t.uniqueArray(e);
                    for (var c = t.getRealEmail($CONF.email), i = 0, l = e.length; l > i; i++) {
                        var f = t.getRealEmail(e[i]);
                        if ($.trim(f.toLowerCase()) === $.trim(c.toLowerCase())) e.splice(i, 1)
                    }
                } catch(u) {
                    FNJSBridge.call("toast", {
                        msg: u
                    })
                }
                break;
            case 3:
                n = t.data.mail.to || [];
                e = t.data.mail.cc || []
            }
            initLogin(function() {
                FNJSBridge.call("replyMail", {
                    type: h,
                    mid: $CONF.mid,
                    recipients: n.slice(0, 50),
                    copier: e.slice(0, 50)
                },
                function(t) {})
            })
        })
    },
    showMore: function() {
        FNJSBridge.call("actionsheet", {
            title: "",
            items: [{
                name: "删除邮件",
                value: 1,
                color: "ff0000"
            }]
        },
        function(t) {
            if (1 == t.data.value) {
                delete localStorage[$CONF.uid + "_rd_" + $CONF.mid];
                FNJSBridge.call("mailDeleteByMid", {
                    mid: $CONF.mid
                },
                function(t) {})
            }
        })
    },
    sendToChat: function() {
        this.collapse();
        FNJSBridge.call("sendToChat", {},
        function(t) {})
    },
    initBodyCallback: function(data, useCache) {
        FNJSBridge.call("viewLoadingClose", {});
        var rawData = data,
        data = eval("(" + data + ")"),
        code = data.code,
        that = this;
        if ("S_OK" === code) {
            var html = "";
            this.data.mail = data["var"];
            if (!this.data.mail) {
                this.data.error = !0;
                this.data.errorMsg = "邮件读取失败";
                this.$update();
                delete localStorage[$CONF.uid + "_rd_" + $CONF.mid];
                return
            }
            this.data.mail.from = this.data.mail.from[0];
            if (this.data.mail.html) html = this.data.mail.html.content || "";
            else html = $Util.convertTextareaEnter(this.data.mail.text.content);
            this.data.mail.content = html;
            var sender = {};
            if (this.data.mail.from) {
                sender.name = this.data.mail.from.name || "";
                sender.addr = this.data.mail.from.addr || ""
            }
            if (this.data.mail.to) FNJSBridge.call("transMail2Name", {
                mailsTo: that.data.mail.to? that.data.mail.to.slice(0, 50):that.data.mail.to,
                mailsFrom: that.data.mail.from,
                mailsCc: that.data.mail.cc?that.data.mail.cc.slice(0, 50):that.data.mail.cc
            },
            function(n) {
                if (n && n.data) {
                    for (var i = n.data.toName,
                    r = n.data.fromName,
                    a = n.data.cc,
                    t = 0,
                    o = i.length; o > t; t++) for (var e in i[t]) if (i[t][e].toLowerCase() === e.toLowerCase()) i[t][e] = e.split("@")[0];
                    for (var t = 0,
                    o = r.length; o > t; t++) for (var e in r[t]) if (r[t][e].toLowerCase() === e.toLowerCase()) r[t][e] = e.split("@")[0];
                    for (var t = 0,
                    o = a.length; o > t; t++) for (var e in a[t]) if (a[t][e].toLowerCase() === e.toLowerCase()) a[t][e] = e.split("@")[0]
                }
                that.data.mailMap = n.data;
                that.$update()
            });
            this.data.mail.sender = sender;
            this.data.mail.subject = this.data.mail.subject || "无主题";
            for (var attachments = this.data.mail.attachments,
            i = 0,
            len = attachments.length; len > i; i++) {
                var att = attachments[i];
                att.size = $Util.parseSize(att.estimateSize);
                att.downloadUrl = "http://" + location.host + "/" + $CONF.appName + "/s?func=mbox:getMessageData&mode=download&requestContentLength=true&sid=" + $CONF.sid + "&mid=" + $CONF.mid + "&part=" + att.id;
                var ext = att.filename.substring(att.filename.lastIndexOf(".") + 1),
                index;
                if (/^(xls|xlsx)$/i.test(ext)) index = 3;
                else if (/^(doc|docx)$/i.test(ext)) index = 12;
                else if (/^(ppt|pptx)$/i.test(ext)) index = 9;
                else if (/^(png|jpg|jpeg|gif|bmp)$/i.test(ext)) index = 14;
                else if (this.data.ext.indexOf(ext) >= 0) index = this.data.ext.indexOf(ext);
                else index = 2;
                att.ext = this.data.ext[index]
            }
            this.data.error = !1;
            if (!useCache) this.saveCache($CONF.mid, rawData)
        } else if ("FA_MAIL_NOT_FOUND" === code) {
            FNJSBridge.call("toast", {
                msg: "信件已经不存在!,mid=" + $CONF.mid
            });
            this.data.error = !0;
            this.data.errorMsg = "信件已经不存在,mid=" + $CONF.mid
        } else if ("FA_INVALID_SESSION" === code) {
            FNJSBridge.call("toast", {
                msg: "登录过期，请重新操作"
            });
            this.data.error = !0;
            this.data.errorMsg = "登录过期，请重新操作"
        } else {
            FNJSBridge.call("toast", {
                msg: "读信失败，错误代码：" + code
            });
            this.data.error = !0;
            this.data.errorMsg = "读信失败，错误代码：" + code
        }
        this.$update();
        $("#from").addClass("ellipsis");
        $Util.ellipsisInCenter("#from");
        $Util.ellipsisInCenter(".file")
    },
    saveCache: function(n, t) {
        try {
            if (t.indexOf("func=mbox:getMessageData") > -1) return ! 1;
            if (localStorage) localStorage[$CONF.uid + "_rd_" + n] = t
        } catch(i) {
            for (var e in localStorage) if (e.indexOf("_rd_") > 0) localStorage.removeItem(e)
        }
    },
    expand: function() {
        this.data.hideDetail = !1;
        sessionStorage.setItem("expand", 1)
    },
    collapse: function() {
        this.data.hideDetail = !0;
        delete sessionStorage["expand"];
        setTimeout(function() {
            $("#from").addClass("ellipsis");
            $Util.ellipsisInCenter("#from")
        },
        0)
    },
    clickAttach: function(t, n, i, e, r, a) {
        initLogin(function() {
            t.origin.style.backgroundColor = "#ebebeb";
            setTimeout(function() {
                if (209715200 > e) FNJSBridge.call("viewAttach", {
                    url: i,
                    size: e,
                    contentType: r,
                    fileName: a,
                    mid: $CONF.mid,
                    part: n
                },
                function(t) {});
                else FNJSBridge.call("alert", {
                    title: "附件过大",
                    message: "请在电脑端下载",
                    buttonName: "知道了"
                });
                t.origin.style.backgroundColor = "#f5f5f5"
            },
            100)
        })
    },
    onGotoard: function(t, e, n) {
        t.origin.className = "active";
        setTimeout(function() {
            t.origin.className = "";
            FNJSBridge.call("userInfo", {
                mail: e,
                alias: n
            },
            function(t) {})
        },
        100)
    },
    initRead: function() {
        var t = $CONF.uid + "_rd_" + $CONF.mid;
        if (localStorage && localStorage[t]) try {
            this.initBodyCallback(localStorage[t], !0)
        } catch(n) {
            FNJSBridge.call("alert", {
                title: "邮件读取失败",
                message: "",
                buttonName: "知道了"
            });
            this.data.error = !0;
            this.data.errorMsg = "邮件解析失败";
            this.$update()
        } else {
            FNJSBridge.call("viewLoading", {
                msg: "数据加载中",
                showIco: !0
            });
            var e = this;
            $.ajax({
                type: "POST",
                headers: {
                    Accept: "text/javascript"
                },
                url: "/" + $CONF.appName + "/s?sid=" + $CONF.sid + "&func=mbox:readMessage",
                data: {
                    "var": '<?xml version="1.0"?><object><string name="id">' + $CONF.mid + '</string><string name="mode">both</string><boolean name="autoName">true</boolean><boolean name="supportTNEF">true</boolean><boolean name="filterStylesheets">true</boolean><boolean name="returnImageInfo">true</boolean><boolean name="markRead">true</boolean></object>'
                },
                dataType: "text",
                success: function(t) {
                    try {
                        e.initBodyCallback(t)
                    } catch(n) {
                        FNJSBridge.call("alert", {
                            title: "邮件读取失败",
                            message: "",
                            buttonName: "知道了"
                        });
                        this.data.error = !0;
                        this.data.errorMsg = "邮件解析失败";
                        this.$update()
                    }
                },
                error: function(t, e) {
                    FNJSBridge.call("toast", {
                        message: "请求失败，请重试~"
                    });
                    FNJSBridge.call("viewLoadingClose", {})
                }
            })
        }
    }
}),
detail = new MailDetail;
function hideElementWhenCapture() {
    var t = document.getElementById("detailLink"),
    e = document.getElementById("footer"),
    n = document.getElementById("attachments");
    if (t) t.style.display = "none";
    if (e) e.style.display = "none";
    if (n) n.style.display = "none"
}
function showElementWhenCaptureBack() {
    var t = document.getElementById("detailLink"),
    e = document.getElementById("footer"),
    n = document.getElementById("attachments");
    if (t) t.style.display = "";
    if (e) e.style.display = "";
    if (n) n.style.display = ""
}
var MailDetail = Regular.extend({
    template: "#container",
    data: {
        ext: ["7z", "csv", "default", "excel", "htm", "html", "mp3", "mp4", "pdf", "ppt", "rar", "txt", "word", "zip", "img"],
        mail: {
            attachments: [],
            subject: "",
            content: "",
            ext: "default",
            sentDate: new Date,
            from: "",
            to: [],
            cc: []
        },
        errorMsg: "",
        error: !0,
        hideDetail: !0
    },
    init: function() {
        if ("1" === sessionStorage["expand"]) this.expand()
    },
    uniqueArray: function(e) {
        for (var i = [], t = 0, r = e.length; r > t; t++) {
            for (var n = t + 1; r > n; n++) if (e[t] === e[n]) n = ++t;
            i.push(e[t])
        }
        return i
    },
    getRealEmail: function(e) {
        var t = e.match(/<([^<>]*)>/g) || [];
        if (t.length) {
            var n = t[t.length - 1];
            return n.substring(1, n.length - 1)
        }
        return e
    },
    showActionSheet: function() {
        var t = this;
        FNJSBridge.call("actionsheet", {
            title: "",
            items: [{
                name: "回复",
                value: 1
            },
            {
                name: "回复全部",
                value: 2
            },
            {
                name: "转发",
                value: 3
            }]
        },
        function(r) {
            var n, e, s = {
                1 : "reply",
                2 : "replyAll",
                3 : "forward"
            },
            a = t.data.mail.from.slice(),
            o = t.data.mail.cc ? t.data.mail.cc.slice() : [],
            h = s[r.data.value];
            switch (r.data.value) {
            case 1:
                n = [a];
                e = [];
                break;
            case 2:
                try {
                    n = [a];
                    e = o.concat(t.data.mail.to || []);
                    e = t.uniqueArray(e);
                    for (var c = t.getRealEmail($CONF.email), i = 0, l = e.length; l > i; i++) {
                        var f = t.getRealEmail(e[i]);
                        if ($.trim(f.toLowerCase()) === $.trim(c.toLowerCase())) e.splice(i, 1)
                    }
                } catch(u) {
                    FNJSBridge.call("toast", {
                        msg: u
                    })
                }
                break;
            case 3:
                n = t.data.mail.to || [];
                e = t.data.mail.cc || []
            }
            initLogin(function() {
                FNJSBridge.call("replyMail", {
                    type: h,
                    mid: $CONF.mid,
                    recipients: n.slice(0, 50),
                    copier: e.slice(0, 50)
                },
                function(t) {})
            })
        })
    },
    showMore: function() {
        FNJSBridge.call("actionsheet", {
            title: "",
            items: [{
                name: "删除邮件",
                value: 1,
                color: "ff0000"
            }]
        },
        function(t) {
            if (1 == t.data.value) {
                delete localStorage[$CONF.uid + "_rd_" + $CONF.mid];
                FNJSBridge.call("mailDeleteByMid", {
                    mid: $CONF.mid
                },
                function(t) {})
            }
        })
    },
    sendToChat: function() {
        this.collapse();
        FNJSBridge.call("sendToChat", {},
        function(t) {})
    },
    initBodyCallback: function(data, useCache) {
        FNJSBridge.call("viewLoadingClose", {});
        var rawData = data,
        data = eval("(" + data + ")"),
        code = data.code,
        that = this;
        if ("S_OK" === code) {
            var html = "";
            this.data.mail = data["var"];
            if (!this.data.mail) {
                this.data.error = !0;
                this.data.errorMsg = "邮件读取失败";
                this.$update();
                delete localStorage[$CONF.uid + "_rd_" + $CONF.mid];
                return
            }
            this.data.mail.from = this.data.mail.from[0];
            if (this.data.mail.html) html = this.data.mail.html.content || "";
            else html = $Util.convertTextareaEnter(this.data.mail.text.content);
            this.data.mail.content = html;
            var sender = {};
            if (this.data.mail.from) {
                sender.name = this.data.mail.from.name || "";
                sender.addr = this.data.mail.from.addr || ""
            }
            if (this.data.mail.to) FNJSBridge.call("transMail2Name", {
                 mailsTo: that.data.mail.to? that.data.mail.to.slice(0, 50):that.data.mail.to,
                 mailsFrom: that.data.mail.from,
                 mailsCc: that.data.mail.cc?that.data.mail.cc.slice(0, 50):that.data.mail.cc
            },
            function(n) {
                if (n && n.data) {
                    for (var i = n.data.toName,
                    r = n.data.fromName,
                    a = n.data.cc,
                    t = 0,
                    o = i.length; o > t; t++) for (var e in i[t]) if (i[t][e].toLowerCase() === e.toLowerCase()) i[t][e] = e.split("@")[0];
                    for (var t = 0,
                    o = r.length; o > t; t++) for (var e in r[t]) if (r[t][e].toLowerCase() === e.toLowerCase()) r[t][e] = e.split("@")[0];
                    for (var t = 0,
                    o = a.length; o > t; t++) for (var e in a[t]) if (a[t][e].toLowerCase() === e.toLowerCase()) a[t][e] = e.split("@")[0];
                }
                that.data.mailMap = n.data;
                that.$update()
            });
            this.data.mail.sender = sender;
            this.data.mail.subject = this.data.mail.subject || "无主题";
            for (var attachments = this.data.mail.attachments,
            i = 0,
            len = attachments.length; len > i; i++) {
                var att = attachments[i];
                att.size = $Util.parseSize(att.estimateSize);
                att.downloadUrl = "http://" + location.host + "/" + $CONF.appName + "/s?func=mbox:getMessageData&mode=download&requestContentLength=true&sid=" + $CONF.sid + "&mid=" + $CONF.mid + "&part=" + att.id;
                var ext = att.filename.substring(att.filename.lastIndexOf(".") + 1),
                index;
                if (/^(xls|xlsx)$/i.test(ext)) index = 3;
                else if (/^(doc|docx)$/i.test(ext)) index = 12;
                else if (/^(ppt|pptx)$/i.test(ext)) index = 9;
                else if (/^(png|jpg|jpeg|gif|bmp)$/i.test(ext)) index = 14;
                else if (this.data.ext.indexOf(ext) >= 0) index = this.data.ext.indexOf(ext);
                else index = 2;
                att.ext = this.data.ext[index]
            }
            this.data.error = !1;
            if (!useCache) this.saveCache($CONF.mid, rawData)
        } else if ("FA_MAIL_NOT_FOUND" === code) {
            FNJSBridge.call("toast", {
                msg: "信件已经不存在!,mid=" + $CONF.mid
            });
            this.data.error = !0;
            this.data.errorMsg = "信件已经不存在,mid=" + $CONF.mid
        } else if ("FA_INVALID_SESSION" === code) {
            FNJSBridge.call("toast", {
                msg: "登录过期，请重新操作"
            });
            this.data.error = !0;
            this.data.errorMsg = "登录过期，请重新操作"
        } else {
            FNJSBridge.call("toast", {
                msg: "读信失败，错误代码：" + code
            });
            this.data.error = !0;
            this.data.errorMsg = "读信失败，错误代码：" + code
        }
        this.$update();
        $("#from").addClass("ellipsis");
        $Util.ellipsisInCenter("#from");
        $Util.ellipsisInCenter(".file")
    },
    saveCache: function(n, t) {
        try {
            if (t.indexOf("func=mbox:getMessageData") > -1) return ! 1;
            if (localStorage) localStorage[$CONF.uid + "_rd_" + n] = t
        } catch(i) {
            for (var e in localStorage) if (e.indexOf("_rd_") > 0) localStorage.removeItem(e)
        }
    },
    expand: function() {
        this.data.hideDetail = !1;
        sessionStorage.setItem("expand", 1)
    },
    collapse: function() {
        this.data.hideDetail = !0;
        delete sessionStorage["expand"];
        setTimeout(function() {
            $("#from").addClass("ellipsis");
            $Util.ellipsisInCenter("#from")
        },
        0)
    },
    clickAttach: function(t, n, i, e, r, a) {
        initLogin(function() {
            t.origin.style.backgroundColor = "#ebebeb";
            setTimeout(function() {
                if (209715200 > e) FNJSBridge.call("viewAttach", {
                    url: i,
                    size: e,
                    contentType: r,
                    fileName: a,
                    mid: $CONF.mid,
                    part: n
                },
                function(t) {});
                else FNJSBridge.call("alert", {
                    title: "附件过大",
                    message: "请在电脑端下载",
                    buttonName: "知道了"
                });
                t.origin.style.backgroundColor = "#f5f5f5"
            },
            100)
        })
    },
    onGotoard: function(t, e, n) {
        t.origin.className = "active";
        setTimeout(function() {
            t.origin.className = "";
            FNJSBridge.call("userInfo", {
                mail: e,
                alias: n
            },
            function(t) {})
        },
        100)
    },
    initRead: function() {
        var t = $CONF.uid + "_rd_" + $CONF.mid;
        if (localStorage && localStorage[t]) try {
            this.initBodyCallback(localStorage[t], !0)
        } catch(n) {
            FNJSBridge.call("alert", {
                title: "邮件读取失败",
                message: "",
                buttonName: "知道了"
            });
            this.data.error = !0;
            this.data.errorMsg = "邮件解析失败";
            this.$update()
        } else {
            FNJSBridge.call("viewLoading", {
                msg: "数据加载中",
                showIco: !0
            });
            var e = this;
            $.ajax({
                type: "POST",
                headers: {
                    Accept: "text/javascript"
                },
                url: "/" + $CONF.appName + "/s?sid=" + $CONF.sid + "&func=mbox:readMessage",
                data: {
                    "var": '<?xml version="1.0"?><object><string name="id">' + $CONF.mid + '</string><string name="mode">both</string><boolean name="autoName">true</boolean><boolean name="supportTNEF">true</boolean><boolean name="filterStylesheets">true</boolean><boolean name="returnImageInfo">true</boolean><boolean name="markRead">true</boolean></object>'
                },
                dataType: "text",
                success: function(t) {
                    try {
                        e.initBodyCallback(t)
                    } catch(n) {
                        FNJSBridge.call("alert", {
                            title: "邮件读取失败",
                            message: "",
                            buttonName: "知道了"
                        });
                        this.data.error = !0;
                        this.data.errorMsg = "邮件解析失败";
                        this.$update()
                    }
                },
                error: function(t, e) {
                    FNJSBridge.call("toast", {
                        message: "请求失败，请重试~"
                    });
                    FNJSBridge.call("viewLoadingClose", {})
                }
            })
        }
    }
});
var detail = new MailDetail;
detail.$inject(document.getElementById("app"));
function initLogin(t) {
    FNJSBridge.call("mailLogin", {},
    function(e) {
        $CONF = $.extend($CONF, e.data);
        $CONF.uid = $CONF.email;
        $CONF.domain = $CONF.email.split("@")[1];
        t && t()
    })
}
document.addEventListener("FNJSBridgeReady",
function() {
    initLogin(function() {
        FNJSBridge.call("mailGetId", {},
        function(t) {
            $CONF.mid = t.data.mid;
            $Login($CONF.uid, $CONF.cookie, detail.initRead.bind(detail))
        })
    })
});